---
title: XRWebGLLayer
slug: Web/API/XRWebGLLayer
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Interface
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRWebGLLayer
---
<div>{{securecontext_header}}{{APIRef("WebXR Device API")}}</div>

<p class="summary"><span class="seoSummary">The <strong><code>XRWebGLLayer</code></strong> interface of the WebXR Device API provides a linkage between the WebXR device (or simulated XR device, in the case of an inline session) and a WebGL context used to render the scene for display on the device.</span> In particular, it provides access to the WebGL framebuffer and viewport to ease access to the context.</p>

<p class="summary">Although <code>XRWebGLLayer</code> is currently the only type of framebuffer layer supported by <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a>, it's entirely possible that future updates to the WebXR specification may allow for other layer types and corresponding image sources.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("XRWebGLLayer.XRWebGLLayer", "new XRWebGLLayer()")}}</dt>
	<dd>Creates and returns a new <code>XRWebGLLayer</code> object for use by the specified {{domxref("XRSession")}}, using a particular {{domxref("WebGLRenderingContext")}} or {{domxref("WebGL2RenderingContext")}} as the destination context.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref('XRWebGLLayer.antialias', "antialias")}} {{ReadOnlyInline}}</dt>
	<dd>A Boolean value indicating whether or not the WebGL context's framebuffer supports anti-aliasing. The specific type of anti-aliasing is determined by the {{Glossary("user agent")}}.</dd>
	<dt>{{domxref('XRWebGLLayer.framebuffer', "framebuffer")}} {{ReadOnlyInline}}</dt>
	<dd>Returns a {{domxref('WebGLFramebuffer')}} suitable for passing into the {{domxref("WebGLRenderingContext.bindFrameBuffer", "bindFrameBuffer()")}} method.</dd>
	<dt>{{domxref('XRWebGLLayer.framebufferWidth', "framebufferWidth")}} {{ReadOnlyInline}}</dt>
	<dd>Returns the width of the <code>XRWebGLLayer</code>'s framebuffer.</dd>
	<dt>{{domxref('XRWebGLLayer.framebufferHeight', "framebufferHeight")}} {{ReadOnlyInline}}</dt>
	<dd>Returns the height of the layer's framebuffer.</dd>
	<dt>{{domxref('XRWebGLLayer.ignoreDepthValues', "ignoreDepthValues")}} {{ReadOnlyInline}}</dt>
	<dd>A Boolean which Indicates whether or not the <a href="en-US/docs/Web/API/WebXR_Device_API/Fundamentals#The_WebXR_compositor">WebXR compositor</a> should make use of the contents of the layer's depth buffer while compositing the scene.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref('XRWebGLLayer.getViewport()', "getViewport()")}}</dt>
	<dd>Returns a new {{domxref('XRViewport')}} instance representing the position, width, and height to which the <a href="/en-US/docs/Web/API/WebGLRenderingContext/viewport">WebGL context's viewport</a> must be set to contain drawing to the area of the framebuffer designated for the specified view's contents. In this way, for example, the rendering of the left eye's point of view and of the right eye's point of view are each placed into the correct parts of the framebuffer.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
	<dt>{{domxref('XRWebGLLayer.getNativeFramebufferScaleFactor()', "getNativeFramebufferScaleFactor()")}}</dt>
	<dd>Returns the scaling factor that can be used to scale the resolution of the recommended WebGL framebuffer resolution to the rendering device's native resolution.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Binding_the_layer_to_a_WebGL_context">Binding the layer to a WebGL context</h3>

<p>This snippet, taken from {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion", "Drawing a frame")}}, shows how the <code>XRWebGLLayer</code> is obtained from the {{domxref("XRSession")}} object's rendering state and is then bound as the current rendering WebGL framebuffer by calling the WebGL {{domxref("WebGLRenderingContext.bindFrameBuffer", "bindFrameBuffer()")}} function.</p>

<pre class="brush: js notranslate">let glLayer = xrSession.renderState.baseLayer;
gl.bindFrameBuffer(gl.FRAMEBUFFER, glLayer.framebuffer);
</pre>

<h3 id="Rendering_every_view_in_a_frame">Rendering every view in a frame</h3>

<p>Each time the GPU is ready to render the scene to the XR device, the XR runtime calls the function you specified when you called the {{domxref("XRSession")}} method {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} to ask to render the frame.</p>

<p>That function receives as input an {{domxref("XRFrame")}} which encapsulates the data needed to render the frame. This information includes the pose (an {{domxref("XRViewerPose")}} object) that describes the position and facing direction of the viewer within the scene as well as a list of {{domxref("XRView")}} objects, each representing one perspective on the scene. In current WebXR implementations, there will never be more than two entries in this list: one describing the position and viewing angle of the left eye and another doing the same for the right.</p>

<pre class="brush: js notranslate">let pose = xrFrame.getViewerPose(xrReferenceSpace);

if (pose) {
  let glLayer = xrSession.renderState.baseLayer;
  gl.bindFrameBuffer(gl.FRAMEBUFFER, glLayer.Framebffer);

  for (let view of pose.views) {
    let viewport = glLayer.getViewport(view);
    gl.viewport(viewport.x, viewport.y, viewport.width, viewport.height);

    /* Render the view */
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('WebXR','#xrwebgllayer-interface','XRWebGLLayer')}}</td>
			<td>{{Spec2('WebXR')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
	<li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
	<li>{{domxref('WebGLRenderingContext')}} and {{domxref("WebGL2RenderingContext")}}</li>
	<li>{{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion", "Drawing a frame")}}</li>
</ul>
